//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Capture.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

TCapture *Capture;
//---------------------------------------------------------------------------

Byte *FrameBuf;
DWORD  *BufUsed;
int  FrameSize;
bool       DelayFlag,SaveFlag,Ready;
int        FrameCount,DelayCount;
int        TriggerLevel,Ahead,Behind;
AnsiString AVIName;
LRESULT CALLBACK capWaveStreamCallback(HWND hWnd,LPWAVEHDR lpWHdr);
LRESULT CALLBACK capVideoStreamCallback(HWND hWnd,LPVIDEOHDR lpVHdr);
LRESULT CALLBACK capYieldCallback(HWND hWnd);
//---------------------------------------------------------------------------
__fastcall TCapture::TCapture(HWND HWnd,int dev)
{
  Handle=HWnd;
  Live=false;
  Pic=new Graphics::TBitmap;
  DEVICENUM=dev;
  XPOS= 0;
  YPOS= 0;
  Pic->Height=240;
  Pic->Width=320;
}

__fastcall TCapture::~TCapture()
{
//  AVIFileExit();
}


void __fastcall TCapture::SetVideoFormat(void)
{
  //]wv榡 ----{b
  CAPTUREPARMS Capture;
  capCaptureGetSetup(Video,&Capture,sizeof(CAPTUREPARMS));
  Capture.fAbortRightMouse=false;
  Capture.fAbortLeftMouse=false;
 //Capture.fAbortLeftMouse=true;
 // Capture.fCaptureAudio=true;               //Enable Audio
  Capture.dwRequestMicroSecPerFrame = 33334; //30 frame Per Sec
  Capture.dwAudioBufferSize = 356; //900301
  capCaptureSetSetup(Video,&Capture,sizeof(CAPTUREPARMS));
}

void __fastcall TCapture::ShowLive(void)
{
  BITMAPINFO bmi;
if(!Live)
 {
  Video = capCreateCaptureWindow("Capture Window",
                               WS_CHILD|WS_VISIBLE,
                               XPOS,YPOS,320,240,
                               Handle,
                               DEVICENUM); //1
  capDriverConnect(Video,0);
  if(!capOverlay(Video,true))
  {
    // capPreviewRate(Video, 100); // PreviewMode!!
     capPreview(Video,true);
  }
  UpdateWindow(Video);
  Live = true;
  SetVideoFormat();

  capGetVideoFormat(Video, &bmi, sizeof(BITMAPINFO));
  SetWindowPos(Video, 0, XPOS, YPOS, bmi.bmiHeader.biWidth,bmi.bmiHeader.biHeight,0);


 }
}

void __fastcall TCapture::StopShowLive(void)
{
  if(Live)
  {
    capDriverDisconnect(Video);
    DestroyWindow(Video);
    Live = false;
    Video = NULL; //900426
  }
}

void __fastcall TCapture::Capturing()
{
  if(capSetCallbackOnYield(Video,capYieldCallback))
  {
      //can handel Message while Captureord
      capCaptureSequenceNoFile(Video); //Capture
  }
}

void __fastcall TCapture::StopCapturing()
{
  capCaptureStop(Video);
}
void __fastcall TCapture::Stop()
{
  capCaptureStop(Video);
  capCaptureAbort(Video);
}



bool __fastcall TCapture::Overlay(bool Flag)
{
  capOverlay(Video,!Flag);
  if(!capOverlay(Video,Flag))
    capPreview(Video,Flag);
}

bool __fastcall TCapture::DlgVideoFormat(void)
{
  return capDlgVideoFormat(Video);
}

bool __fastcall TCapture::DlgVideoSource(void)
{
  return capDlgVideoSource(Video);
}

bool __fastcall TCapture::DlgVideoDisplay(void)
{
  return capDlgVideoDisplay(Video);
}
HWND __fastcall TCapture::test()
{
  capGrabFrameNoStop(Video);
  capEditCopy(Video);
  Pic->Height=240;
  Pic->Width=320;
  if(Clipboard()->HasFormat(CF_DIB))
  {
    Pic->Assign(Clipboard());
  }
   return(Pic->Canvas->Handle);
}

void __fastcall TCapture::Setpos(int pos_x,int pos_y)
{
  XPOS= pos_x;
  YPOS= pos_y;
}
//****************YieldCallback******************************
LRESULT CALLBACK capYieldCallback(HWND hWnd)
{//can handel Message while Captureord
/*
////////////////////////////////////////////////////////////////////////
//  hWnd:           Application main window handle
////////////////////////////////////////////////////////////////////////
 MSG msg;

    if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    // Return TRUE to continue capturing
    return (LRESULT) TRUE; */
}
void __fastcall TCapture::SetAVIFile(AnsiString FileName)
{
  AVIName=FileName;
}
  void __fastcall TCapture::Start_save_AVI()
{
   capFileSetCaptureFile(Video,AVIName.c_str());
   capCaptureSequence (Video);
}
void __fastcall TCapture::Stop_Save_AVI()
{
   //
}

